Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports Outlook = Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("C03282CB-2CDA-4E1E-93AD-801688D45A4B"), ProgIdAttribute("NewEmailsExample.AddinModule"), RunInstaller(True)> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents

    Private eventObject As OutlookItemsEventsClass1

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        '
        'AddinModule
        '
        Me.AddinName = "NewEmailsExample"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub
 
#End Region
 
#Region " ADX automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Add any initialization after the InitializeComponent() call
 
    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return HostApplication
        End Get
    End Property

    Private Sub adxOutlookEvents_NewMail(ByVal sender As Object, ByVal e As System.EventArgs) Handles adxOutlookEvents.NewMail
        ' nothing
    End Sub

    Private Sub adxOutlookEvents_NewMailEx(ByVal sender As Object, ByVal entryIDCollection As String) Handles adxOutlookEvents.NewMailEx
        Dim ids As String() = entryIDCollection.Split(",")
        Dim i As Integer

        For i = 0 To ids.Length - 1
            If AddNamedProperty(ids(i), "MyNamedProperty", "My Property Value.") Then

            End If
        Next i

    End Sub

    Private Function AddNamedProperty(ByVal entryID As String, ByVal propertyName As String, ByVal _value As String) As Boolean
        Dim obj As Object = Nothing
        Dim retVal As Boolean = False
        Dim mail As IMAPIProp = Nothing
        Dim ns As Outlook._NameSpace = Nothing
        Dim mailObj As Outlook._MailItem = Nothing

        Try
            ns = OutlookApp.GetNamespace("MAPI")
            obj = ns.GetItemFromID(entryID, Nothing)
            mailObj = CType(obj, Outlook.MailItem)
            Try
                mail = CType(mailObj.MAPIOBJECT, IMAPIProp)

                Dim p As IntPtr = IntPtr.Zero
                Dim lpszStr As IntPtr = IntPtr.Zero
                Dim propTags As IntPtr = IntPtr.Zero
                Dim lpszValue As IntPtr = IntPtr.Zero
                Dim lpProblems As IntPtr = IntPtr.Zero
                Dim lpPropValue As IntPtr = IntPtr.Zero
                Dim _mapiNameID As IntPtr = IntPtr.Zero
                Dim propValue As SPropValue = New SPropValue
                Dim mapiNameID As MAPINAMEID = New MAPINAMEID

                Try
                    Dim g As Guid = Guid.NewGuid()
                    _mapiNameID = Marshal.AllocHGlobal(Marshal.SizeOf(mapiNameID))

                    p = Marshal.AllocHGlobal(Marshal.SizeOf(g))
                    Marshal.StructureToPtr(g, p, False)
                    mapiNameID.lpguid = p
                    mapiNameID.ulKind = 1
                    lpszStr = Marshal.StringToHGlobalUni(propertyName)
                    mapiNameID.lpwstrName = lpszStr
                    Marshal.StructureToPtr(mapiNameID, _mapiNameID, False)

                    If mail.GetIDsFromNames(1, _mapiNameID, &H2, propTags) = MAPI.S_OK Then
                        Dim count As Integer = Marshal.ReadInt32(propTags)

                        If count = 1 Then
                            Dim tag As Integer = Marshal.ReadInt32(New IntPtr(propTags.ToInt32() + 4))
                            tag = (tag Or MAPI.PT_STRING8)
                            lpPropValue = Marshal.AllocHGlobal(Marshal.SizeOf(propValue))
                            propValue.ulPropTag = tag
                            propValue.dwAlignPad = 0
                            lpszValue = Marshal.StringToHGlobalAnsi(_value)
                            propValue.Value = lpszValue.ToInt64()
                            Marshal.StructureToPtr(propValue, lpPropValue, False)

                            If mail.SetProps(1, lpPropValue, lpProblems) = MAPI.S_OK Then
                                If mail.SaveChanges(&H4) = MAPI.S_OK Then
                                    retVal = True
                                End If
                            End If

                        End If

                    End If

                Finally
                    If Not lpszValue.Equals(IntPtr.Zero) Then
                        Marshal.FreeHGlobal(lpszValue)
                    End If
                    If Not lpPropValue.Equals(IntPtr.Zero) Then
                        Marshal.FreeHGlobal(lpPropValue)
                    End If
                    If Not propTags.Equals(IntPtr.Zero) Then
                        MAPI.MAPIFreeBuffer(propTags)
                    End If
                    If Not p.Equals(IntPtr.Zero) Then
                        Marshal.FreeHGlobal(p)
                    End If
                    If Not lpszStr.Equals(IntPtr.Zero) Then
                        Marshal.FreeHGlobal(lpszStr)
                    End If
                    If Not _mapiNameID.Equals(IntPtr.Zero) Then
                        Marshal.FreeHGlobal(_mapiNameID)
                    End If
                End Try

            Finally
                If Not (mail Is Nothing) Then
                    Marshal.ReleaseComObject(mail)
                End If
            End Try
        Catch

        Finally
            If Not obj Is Nothing Then
                Marshal.ReleaseComObject(obj)
            End If
            If Not ns Is Nothing Then
                Marshal.ReleaseComObject(ns)
            End If
        End Try

        Return retVal

    End Function

    Private Sub AddinModule_AddinStartupComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AddinStartupComplete

        If HostVersion.IndexOf("9.") = 0 Then
            eventObject = New OutlookItemsEventsClass1(Me)
            eventObject.ConnectTo(AddinExpress.MSO.ADXOlDefaultFolders.olFolderInbox, True)
        End If

    End Sub

    Private Sub AddinModule_AddinBeginShutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AddinBeginShutdown

        If Not eventObject Is Nothing Then
            eventObject.Dispose()
        End If

    End Sub
End Class

