Imports System
Imports System.Runtime.InteropServices

Friend Class MAPI
    Public Const S_OK As Integer = 0

    Public Const PR_TRANSPORT_MESSAGE_HEADERS As Integer = &H7D001E
    Public Const PR_BODY As Integer = &H1000001E
    Public Const PR_BODY_HTML As Integer = &H1013001E
    Public Const PR_HTML As Integer = &H10130102

    Public Const MV_FLAG As Integer = &H1000

    Public Const PT_UNSPECIFIED As Integer = 0
    Public Const PT_NULL As Integer = 1
    Public Const PT_I2 As Integer = 2
    Public Const PT_LONG As Integer = 3
    Public Const PT_R4 As Integer = 4
    Public Const PT_DOUBLE As Integer = 5
    Public Const PT_CURRENCY As Integer = 6
    Public Const PT_APPTIME As Integer = 7
    Public Const PT_ERROR As Integer = 10
    Public Const PT_BOOLEAN As Integer = 11
    Public Const PT_OBJECT As Integer = 13
    Public Const PT_I8 As Integer = 20
    Public Const PT_STRING8 As Integer = 30
    Public Const PT_UNICODE As Integer = 31
    Public Const PT_SYSTIME As Integer = 64
    Public Const PT_CLSID As Integer = 72
    Public Const PT_BINARY As Integer = 258
    Public Const PT_MV_TSTRING As Integer = (MV_FLAG Or PT_STRING8)

    Public Const PR_SENDER_ADDRTYPE As Integer = (PT_STRING8 Or (&HC1E << 16))
    Public Const PR_SENDER_EMAIL_ADDRESS As Integer = (PT_STRING8 Or (&HC1F << 16))
    Public Const PR_SENDER_NAME As Integer = (PT_STRING8 Or (&HC1A << 16))
    Public Const PR_ADDRTYPE As Integer = (PT_STRING8 Or (&H3002 << 16))
    Public Const PR_ADDRTYPE_W As Integer = (PT_UNICODE Or (&H3002 << 16))
    Public Const PR_EMAIL_ADDRESS As Integer = (PT_STRING8 Or (&H3003 << 16))
    Public Const PR_EMAIL_ADDRESS_W As Integer = (PT_UNICODE Or (&H3003 << 16))
    Public Const PR_DISPLAY_NAME As Integer = (PT_STRING8 Or (&H3001 << 16))
    Public Const PR_DISPLAY_NAME_W As Integer = (PT_UNICODE Or (&H3001 << 16))
    Public Const PR_ENTRYID As Integer = (PT_BINARY Or (&HFFF << 16))
    Public Const PR_EMS_AB_PROXY_ADDRESSES As Integer = (PT_MV_TSTRING Or (&H800F << 16))


    Public Const MAPI_NEW_SESSION As Integer = &H2
    Public Const MAPI_FORCE_DOWNLOAD As Integer = &H1000
    Public Const MAPI_LOGON_UI As Integer = &H1
    Public Const MAPI_ALLOW_OTHERS As Integer = &H8
    Public Const MAPI_EXPLICIT_PROFILE As Integer = &H10
    Public Const MAPI_EXTENDED As Integer = &H20
    Public Const MAPI_SERVICE_UI_ALWAYS As Integer = &H2000
    Public Const MAPI_NO_MAIL As Integer = &H8000
    Public Const MAPI_USE_DEFAULT As Integer = &H40

    Public Const AB_NO_DIALOG As Integer = &H1
    Public Const MAPI_DIALOG As Integer = &H8

    <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="MAPIFreeBuffer@4")> _
    Public Shared Sub MAPIFreeBuffer(ByVal lpBuffer As IntPtr)
    End Sub

End Class

Public Structure SPropValue
    Public ulPropTag As Integer
    Public dwAlignPad As Integer
    Public Value As Long
End Structure

Public Structure ADRENTRY
    Public ulReserved1 As Integer
    Public cValues As Integer
    Public rgPropVals As IntPtr
End Structure

Public Structure ADRLIST
    Public cEntries As Integer
    Public aEntries As ADRENTRY
End Structure

Public Structure MAPINAMEID
    Public lpguid As IntPtr
    Public ulKind As Integer
    Public lpwstrName As IntPtr
End Structure

<ComImport(), ComVisible(False), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), _
Guid("00020303-0000-0000-C000-000000000046")> _
Public Interface IMAPIProp
    Function GetLastError(ByVal hResult As Integer, ByVal ulFlags As Integer, ByRef lppMAPIError As IntPtr) As Integer
    Function SaveChanges(ByVal ulFlags As Integer) As Integer
    Function GetProps(ByVal lpPropTagArray As IntPtr, ByVal ulFlags As Integer, ByRef lpcValues As Integer, ByRef lppPropArray As IntPtr) As Integer
    Function GetPropList(ByVal ulFlags As Integer, ByRef lppPropTagArray As IntPtr) As Integer
    Function OpenProperty(ByVal ulPropTag As Integer, ByRef lpiid As Guid, ByVal ulInterfaceOptions As Integer, ByVal ulFlags As Integer, ByRef lppUnk As IntPtr) As Integer
    Function SetProps(ByVal cValues As Integer, ByVal lpPropArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
    Function DeleteProps(ByVal lpPropTagArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
    Function CopyTo(ByVal ciidExclude As Integer, ByRef rgiidExclude As Guid, ByVal lpExcludeProps As IntPtr, ByVal ulUIParam As Integer, _
        ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, ByVal lpDestObj As IntPtr, ByVal ulFlags As Integer, ByRef lppProblems As IntPtr) As Integer
    Function CopyProps(ByVal lpIncludeProps As IntPtr, ByVal ulUIParam As Integer, ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, _
        ByVal lpDestObj As IntPtr, ByVal ulFlags As Integer, ByRef lppProblems As IntPtr) As Integer
    Function GetNamesFromIDs(ByRef lppPropTags As IntPtr, ByRef lpPropSetGuid As Guid, ByVal ulFlags As Integer, _
        ByRef lpcPropNames As Integer, ByRef lpppPropNames As IntPtr) As Integer
    Function GetIDsFromNames(ByVal cPropNames As Integer, ByRef lppPropNames As IntPtr, ByVal ulFlags As Integer, ByRef lppPropTags As IntPtr) As Integer
End Interface

